Index: java/main/src/main/java/com/framsticks/communication/ClientSideManagedConnection.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/ClientSideManagedConnection.java	(revision 98)
+++ java/main/src/main/java/com/framsticks/communication/ClientSideManagedConnection.java	(revision 99)
@@ -2,9 +2,10 @@
 
 import com.framsticks.communication.queries.ApplicationRequest;
+import com.framsticks.communication.queries.CallRequest;
 import com.framsticks.communication.queries.ProtocolRequest;
-import com.framsticks.communication.queries.RegistrationRequest;
+import com.framsticks.communication.queries.RegisterRequest;
 import com.framsticks.communication.queries.UseRequest;
 import com.framsticks.communication.queries.VersionRequest;
-import com.framsticks.communication.util.LoggingStateCallback;
+import com.framsticks.core.Path;
 import com.framsticks.params.ListSource;
 import com.framsticks.util.*;
@@ -18,4 +19,5 @@
 import com.framsticks.util.lang.Pair;
 import com.framsticks.util.lang.Strings;
+import com.framsticks.params.EventListener;
 
 import org.apache.log4j.Logger;
@@ -32,8 +34,7 @@
 	private final static Logger log = Logger.getLogger(ClientSideManagedConnection.class);
 
-	protected final Map<String, Subscription<?>> subscriptions = new HashMap<>();
-
 	private final List<Runnable> applicationRequestsBuffer = new LinkedList<>();
 	private boolean isHandshakeDone = false;
+
 
 	/**
@@ -93,22 +94,11 @@
 	}
 
-	private static class EventFire extends InboundMessage {
-		public final Subscription<?> subscription;
-
-		private EventFire(Subscription<?> subscription) {
-			this.subscription = subscription;
-		}
-
-		public void startFile(String path) {
-			assert path == null;
-			initCurrentFile(null);
-		}
-
-		@Override
-		public void eof() {
-			finishCurrentFile();
-
-			subscription.dispatchCall(getFiles());
-		}
+	protected List<String> readFileContent() {
+		List<String> content = new LinkedList<String>();
+		String line;
+		while (!(line = getLine()).startsWith("eof")) {
+			content.add(line);
+		}
+		return content;
 	}
 
@@ -239,22 +229,4 @@
 	}
 
-	public <C> void subscribe(final String path, final Dispatcher<C> dispatcher, final SubscriptionCallback<? extends C> callback) {
-		send(new RegistrationRequest().path(path), AtOnceDispatcher.getInstance(), new ClientSideResponseFuture(callback) {
-			@Override
-			protected void processOk(Response response) {
-				assert response.getFiles().isEmpty();
-				Subscription<C> subscription = new Subscription<C>(ClientSideManagedConnection.this, path, response.getComment(), dispatcher);
-				log.debug("registered on event: " + subscription);
-				synchronized (subscriptions) {
-					subscriptions.put(subscription.getRegisteredPath(), subscription);
-				}
-				subscription.setEventCallback(callback.subscribed(subscription));
-				if (subscription.getEventCallback() == null) {
-					log.info("subscription for " + path + " aborted");
-					subscription.unsubscribe(new LoggingStateCallback(log, "abort subscription"));
-				}
-			}
-		});
-	}
 
 	private void sendQueryVersion(final int version, final Future<Void> future) {
@@ -322,15 +294,22 @@
 		Matcher matcher = Request.EVENT_PATTERN.matcher(rest);
 		if (!matcher.matches()) {
-			log.error("invalid event line: " + rest);
-			return;
-		}
-		Subscription<?> subscription = subscriptions.get(matcher.group(1));
-		if (subscription == null) {
-			log.error("non subscribed event: " + matcher.group(1));
-			return;
-		}
-		EventFire event = new EventFire(subscription);
-		event.startFile(null);
-		processMessage(event);
+			throw new FramsticksException().msg("invalid event line").arg("rest", rest);
+		}
+		String fileLine = getLine();
+		if (!fileLine.equals("file")) {
+			throw new FramsticksException().msg("expected file line").arg("got", fileLine);
+		}
+		String eventObjectPath = Request.takeGroup(rest, matcher, 1).toString();
+		String eventCalleePath = Request.takeGroup(rest, matcher, 2).toString();
+		final File file = new File("", new ListSource(readFileContent()));
+		log.debug("firing event " + eventObjectPath);
+		EventListener<File> listener;
+		synchronized (registeredListeners) {
+			listener = registeredListeners.get(eventObjectPath);
+		}
+		if (listener  == null) {
+			throw new FramsticksException().msg("failed to find registered event").arg("event path", eventObjectPath).arg("object", eventCalleePath);
+		}
+		listener.action(file);
 	}
 
@@ -397,3 +376,45 @@
 	}
 
+	protected final Map<String, EventListener<File>> registeredListeners = new HashMap<>();
+
+	public <C> void addListener(String path, final EventListener<File> listener, final Dispatcher<C> dispatcher, final Future<Void> future) {
+		send(new RegisterRequest().path(path), dispatcher, new ClientSideResponseFuture(future) {
+			@Override
+			protected void processOk(Response response) {
+				synchronized (registeredListeners) {
+					registeredListeners.put(Path.validateString(response.getComment()), listener);
+				}
+				future.pass(null);
+			}
+		});
+	}
+
+	public <C> void removeListener(EventListener<File> listener, final Dispatcher<C> dispatcher, final Future<Void> future) {
+		String eventPath = null;
+		synchronized (registeredListeners) {
+			for (Map.Entry<String, EventListener<File>> e : registeredListeners.entrySet()) {
+				if (e.getValue() == listener) {
+					eventPath = e.getKey();
+					break;
+				}
+			}
+		}
+		if (eventPath == null) {
+			future.handle(new FramsticksException().msg("listener is not registered").arg("listener", listener));
+			return;
+		}
+
+		final String finalEventPath = eventPath;
+				//TODO add arguments to the exception
+		send(new CallRequest().procedure("remove").path(eventPath), dispatcher, new ClientSideResponseFuture(future) {
+
+			@Override
+			protected void processOk(Response response) {
+				synchronized (registeredListeners) {
+					registeredListeners.remove(finalEventPath);
+				}
+				future.pass(null);
+			}
+		});
+	}
 }
Index: java/main/src/main/java/com/framsticks/communication/Request.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/Request.java	(revision 98)
+++ java/main/src/main/java/com/framsticks/communication/Request.java	(revision 99)
@@ -37,5 +37,5 @@
 			case "info": return new InfoRequest();
 			case "call": return new CallRequest();
-			case "reg": return new RegistrationRequest();
+			case "reg": return new RegisterRequest();
 			case "use": return new UseRequest();
 			case "version": return new VersionRequest();
Index: java/main/src/main/java/com/framsticks/communication/ServerSideManagedConnection.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/ServerSideManagedConnection.java	(revision 98)
+++ java/main/src/main/java/com/framsticks/communication/ServerSideManagedConnection.java	(revision 99)
@@ -68,4 +68,25 @@
 	}
 
+	protected final void putFile(File file, String outId) {
+		putLine("file" + outId/* + " " + f.getPath()*/);
+		SourceInterface content = file.getContent();
+		String line;
+		while ((line = content.readLine()) != null) {
+			putLine(line);
+		}
+		putLine("eof");
+	}
+
+	public final void sendFile(final String header, final File file) {
+		senderThread.dispatch(new RunAt<Connection>(requestHandler) {
+			@Override
+			protected void runAt() {
+				putLine(header);
+				putFile(file, "");
+				flushOut();
+			}
+		});
+	}
+
 	protected final void respond(final Response response, final Integer id) {
 		senderThread.dispatch(new RunAt<Connection>(requestHandler) {
@@ -75,11 +96,5 @@
 				if (response.getFiles() != null) {
 					for (File f : response.getFiles()) {
-						putLine("file" + outId/* + " " + f.getPath()*/);
-						SourceInterface content = f.getContent();
-						String line;
-						while ((line = content.readLine()) != null) {
-							putLine(line);
-						}
-						putLine("eof");
+						putFile(f, outId);
 					}
 				}
@@ -87,5 +102,5 @@
 				statusLine.append(response.getOk() ? "ok" : "error").append(outId);
 				if (Strings.notEmpty(response.getComment())) {
-					statusLine.append(" \"").append(response.getComment()).append('"');
+					Request.quoteValue(statusLine.append(" "), response.getComment());
 				}
 				putLine(statusLine.toString());
Index: java/main/src/main/java/com/framsticks/communication/ServerSideResponseFuture.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/ServerSideResponseFuture.java	(revision 98)
+++ java/main/src/main/java/com/framsticks/communication/ServerSideResponseFuture.java	(revision 99)
@@ -11,5 +11,5 @@
 	@Override
 	public final void handle(FramsticksException e) {
-		result(new Response(false, e.getClass().getCanonicalName() + ": " + e.getMsg(), null));
+		result(new Response(false, e.getClass().getCanonicalName() + ": " + e.getMessage(), null));
 	}
 
Index: java/main/src/main/java/com/framsticks/communication/queries/ApplicationRequest.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/queries/ApplicationRequest.java	(revision 98)
+++ java/main/src/main/java/com/framsticks/communication/queries/ApplicationRequest.java	(revision 99)
@@ -23,4 +23,8 @@
 	}
 
+	public String getActualPath() {
+		return path;
+	}
+
 
 	@Override
Index: java/main/src/main/java/com/framsticks/communication/queries/RegisterRequest.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/queries/RegisterRequest.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/communication/queries/RegisterRequest.java	(revision 99)
@@ -0,0 +1,40 @@
+package com.framsticks.communication.queries;
+
+import com.framsticks.core.Path;
+import com.framsticks.util.lang.Pair;
+
+/**
+ * @author Piotr Sniegowski
+ */
+public class RegisterRequest extends ApplicationRequest {
+
+	protected String actualPath;
+	protected String eventName;
+
+	public RegisterRequest register() {
+		return this;
+	}
+
+	public String getCommand() {
+		return "reg";
+	}
+
+	@Override
+	public RegisterRequest path(String path) {
+		super.path(path);
+		Pair<String, String> p = Path.removeLastElement(path);
+		actualPath = p.first;
+		eventName = p.second;
+		return this;
+	}
+
+	@Override
+	public String getActualPath() {
+		return actualPath;
+	}
+
+	public String getEventName() {
+		return eventName;
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/core/AbstractTree.java
===================================================================
--- java/main/src/main/java/com/framsticks/core/AbstractTree.java	(revision 98)
+++ java/main/src/main/java/com/framsticks/core/AbstractTree.java	(revision 99)
@@ -32,5 +32,5 @@
 public abstract class AbstractTree extends AbstractJoinable implements Dispatcher<Tree>, Tree, JoinableParent {
 
-	private static final Logger log = Logger.getLogger(Tree.class);
+	private static final Logger log = Logger.getLogger(AbstractTree.class);
 
 	private Node root = null;
@@ -45,5 +45,5 @@
 		}
 		root = new Node(this, param, null);
-		log.info("assigned root type: " + root);
+		log.debug("assigned root type: " + root);
 	}
 
@@ -57,5 +57,5 @@
 		}
 		root = new Node(this, root.getParam(), object);
-		log.info("assigned root object: " + root);
+		log.debug("assigned root object: " + root);
 	}
 
@@ -177,4 +177,12 @@
 	}
 
+	/**
+	 * @return the registry
+	 */
+	@Override
+	public Registry getRegistry() {
+		return registry;
+	}
+
 	@Override
 	protected void joinableStart() {
Index: java/main/src/main/java/com/framsticks/core/Framsticks.java
===================================================================
--- java/main/src/main/java/com/framsticks/core/Framsticks.java	(revision 98)
+++ java/main/src/main/java/com/framsticks/core/Framsticks.java	(revision 99)
@@ -21,4 +21,6 @@
 	public Framsticks() {
 		PropertyConfigurator.configure(getClass().getResource("/configs/log4j.properties"));
+
+		// log.info("config is: " + System.getProperties().getProperty("framsticks.config", "/configs/framsticks.xml"));
 	}
 
Index: java/main/src/main/java/com/framsticks/core/LocalTree.java
===================================================================
--- java/main/src/main/java/com/framsticks/core/LocalTree.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/core/LocalTree.java	(revision 99)
@@ -0,0 +1,139 @@
+package com.framsticks.core;
+
+import org.apache.log4j.Logger;
+
+import com.framsticks.params.AccessInterface;
+import com.framsticks.params.CompositeParam;
+import com.framsticks.params.EventListener;
+import com.framsticks.params.FramsClass;
+import com.framsticks.params.ParamBuilder;
+import com.framsticks.params.PrimitiveParam;
+import com.framsticks.params.ValueParam;
+import com.framsticks.params.annotations.AutoAppendAnnotation;
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.params.types.EventParam;
+import com.framsticks.params.types.ProcedureParam;
+import com.framsticks.util.FramsticksException;
+import com.framsticks.util.dispatching.Future;
+
+import static com.framsticks.core.TreeOperations.*;
+
+@FramsClassAnnotation
+public final class LocalTree extends AbstractTree {
+	private static final Logger log = Logger.getLogger(LocalTree.class);
+
+	protected Object rootObject;
+
+	/**
+	 *
+	 */
+	public LocalTree() {
+		super();
+
+	}
+
+	@AutoAppendAnnotation
+	public void setRootObject(Object object) {
+		final Class<?> javaClass = object.getClass();
+		registry.registerAndBuild(javaClass);
+
+		AccessInterface access = registry.createAccess(javaClass);
+
+		assignRootParam(access.buildParam(new ParamBuilder()).id(getName()).finish(CompositeParam.class));
+		assignRootObject(object);
+	}
+
+	public Object getRootObject() {
+		return getAssignedRoot().getObject();
+	}
+
+	public <T> T getRootObject(Class<T> type) {
+		Object result = getRootObject();
+		if (result == null) {
+			throw new FramsticksException().msg("object tree is empty").arg("tree", this);
+		}
+		if (!type.isInstance(result)) {
+			throw new FramsticksException().msg("object tree holds object of different kind").arg("object", result).arg("requested", type).arg("tree", this);
+		}
+		return type.cast(result);
+	}
+
+	@Override
+	public void get(Path path, Future<Path> future) {
+		assert isActive();
+		log.debug("requesting: " + path);
+		path = resolveTopSync(path);
+		future.pass(path);
+	}
+
+	@Override
+	public void get(Path path, ValueParam param, Future<Object> future) {
+		assert isActive();
+		path = resolveTopSync(path);
+		future.pass(bindAccess(path).get(param, Object.class));
+	}
+
+	@Override
+	public void call(Path path, ProcedureParam param, Object[] arguments, Future<Object> future) {
+		assert isActive();
+		try {
+			future.pass(bindAccess(path).call(param, arguments));
+		} catch (FramsticksException e) {
+			future.handle(e);
+		}
+	}
+
+	@Override
+	public void info(Path path, Future<FramsClass> future) {
+		assert isActive();
+		Path p = path.tryResolveIfNeeded();
+		Class<?> javaClass = p.getTopObject().getClass();
+		FramsClass framsClass = registry.registerReflectedIfNeeded(javaClass);
+		if (framsClass != null) {
+			future.pass(framsClass);
+		} else {
+			future.handle(new FramsticksException().msg("failed to find info for class").arg("java class", javaClass));
+		}
+	}
+
+	protected Path resolveTopSync(Path path) {
+		assert isActive();
+		assert path.isOwner(this);
+		if (path.getTop().getObject() != null) {
+			return path;
+		}
+		AccessInterface access = bindAccess(path.getUnder());
+		Object object = access.get(path.getTop().getParam(), Object.class);
+		if (object == null) {
+			throw new FramsticksException().msg("failed to resolve").arg("path", path);
+		}
+		return path.appendResolution(object);
+	}
+
+
+	@Override
+	public void set(Path path, PrimitiveParam<?> param, Object value, final Future<Integer> future) {
+		assert isActive();
+		future.pass(bindAccess(path).set(param, value));
+	}
+
+	public <A> void addListener(Path path, EventParam param, EventListener<A> listener, Class<A> argumentType, Future<Void> future) {
+		assert isActive();
+		try {
+			bindAccess(path).reg(param, listener);
+			future.pass(null);
+		} catch (FramsticksException e) {
+			future.handle(e);
+		}
+	}
+
+	public void removeListener(Path path, EventParam param, EventListener<?> listener, Future<Void> future) {
+		assert isActive();
+		try {
+			bindAccess(path).regRemove(param, listener);
+			future.pass(null);
+		} catch (FramsticksException e) {
+			future.handle(e);
+		}
+	}
+}
Index: java/main/src/main/java/com/framsticks/core/Path.java
===================================================================
--- java/main/src/main/java/com/framsticks/core/Path.java	(revision 98)
+++ java/main/src/main/java/com/framsticks/core/Path.java	(revision 99)
@@ -6,8 +6,12 @@
 import com.framsticks.util.FramsticksException;
 import com.framsticks.util.dispatching.Dispatching;
+import com.framsticks.util.dispatching.ExceptionResultHandler;
+import com.framsticks.util.dispatching.IgnoreExceptionHandler;
+import com.framsticks.util.lang.Pair;
 
 import java.util.Iterator;
 import java.util.LinkedList;
 import java.util.List;
+import java.util.regex.Pattern;
 
 import javax.annotation.Nonnull;
@@ -27,5 +31,5 @@
 	final LinkedList<Node> nodes;
 
-	protected static Object getKnownChild(Tree tree, AccessInterface access, CompositeParam param) {
+	protected static Object getKnownChild(Tree tree, AccessInterface access, CompositeParam param, ExceptionResultHandler handler) {
 		Object child = access.get(param, Object.class);
 		if (child == null) {
@@ -36,4 +40,5 @@
 			return child;
 		} catch (FramsticksException e) {
+			handler.handle(e);
 		}
 		return null;
@@ -130,6 +135,9 @@
 		}
 
-
 		public PathBuilder resolve(@Nonnull Tree tree, String textual) {
+			return resolve(tree, textual, IgnoreExceptionHandler.getInstance());
+		}
+
+		public PathBuilder resolve(@Nonnull Tree tree, String textual, ExceptionResultHandler handler) {
 
 			assert nodes.isEmpty();
@@ -146,12 +154,14 @@
 				String e = i.next();
 				Param p = access.getParam(e);
+				if (p == null) {
+					break;
+				}
 				if (!(p instanceof CompositeParam)) {
-					//entries.add(new Entry());
-					break;
-				}
-				CompositeParam c = (CompositeParam)p;
+					throw new FramsticksException().msg("param is not a composite").arg("param", p).arg("tree", tree).arg("textual", textual).arg("access", access);
+				}
+				CompositeParam c = (CompositeParam) p;
 				b.append("/").append(e);
 				access.select(current.getObject());
-				current = new Node(current.getTree(), c, getKnownChild(tree, access, c));
+				current = new Node(current.getTree(), c, getKnownChild(tree, access, c, handler));
 				nodes.add(current);
 			}
@@ -245,5 +255,5 @@
 			return Path.build().resolve(tree, "/").finish();
 		}
-		Object child = getKnownChild(tree, TreeOperations.bindAccess(getUnder()), getTop().getParam());
+		Object child = getKnownChild(tree, TreeOperations.bindAccess(getUnder()), getTop().getParam(), IgnoreExceptionHandler.getInstance());
 		if (child == null) {
 			return this;
@@ -274,6 +284,14 @@
 	}
 
+	public static Path tryTo(@Nonnull Tree tree, String textual) {
+		return Path.build().resolve(tree, textual).finish();
+	}
+
 	public static Path to(@Nonnull Tree tree, String textual) {
-		return Path.build().resolve(tree, textual).finish();
+		Path path = tryTo(tree, textual);
+		if (path.getTextual().equals(textual)) {
+			return path;
+		}
+		throw new FramsticksException().msg("failed to create path").arg("textual", textual).arg("result", path).arg("tree", tree);
 	}
 
@@ -299,4 +317,37 @@
 	}
 
+	public static final Pattern pathPattern = Pattern.compile("(\\/)|((\\/[^/]+)+)");
+
+	public static boolean isValidString(String path) {
+		return pathPattern.matcher(path).matches();
+	}
+
+	public static String appendString(String path, String element) {
+		if (path.equals("/")) {
+			return path + element;
+		}
+		return path + "/" + element;
+	}
+
+	public static Pair<String, String> removeLastElement(String path) {
+		assert isValidString(path);
+		if (path.equals("/")) {
+			throw new FramsticksException().msg("cannot remove last element from root path");
+		}
+		int index = path.lastIndexOf('/');
+		assert index != -1;
+		if (index == 0) {
+			return new Pair<String, String>("/", path.substring(1));
+		}
+		return new Pair<String, String>(path.substring(0, index), path.substring(index + 1));
+	}
+
+	public static String validateString(String path) {
+		if (!isValidString(path)) {
+			throw new FramsticksException().msg("path string validation failured").arg("path", path);
+		}
+		return path;
+	}
+
 
 	// public boolean isEmpty() {
Index: java/main/src/main/java/com/framsticks/core/Tree.java
===================================================================
--- java/main/src/main/java/com/framsticks/core/Tree.java	(revision 98)
+++ java/main/src/main/java/com/framsticks/core/Tree.java	(revision 99)
@@ -5,8 +5,10 @@
 import com.framsticks.params.AccessInterface;
 import com.framsticks.params.CompositeParam;
+import com.framsticks.params.EventListener;
 import com.framsticks.params.FramsClass;
 import com.framsticks.params.PrimitiveParam;
 import com.framsticks.params.Registry;
 import com.framsticks.params.ValueParam;
+import com.framsticks.params.types.EventParam;
 import com.framsticks.params.types.ProcedureParam;
 import com.framsticks.util.dispatching.Dispatcher;
@@ -34,7 +36,7 @@
 	 *
 	 */
-	public void get(Path path, ValueParam param, Mode mode, Future<Object> future);
+	public void get(Path path, ValueParam param, Future<Object> future);
 
-	public void get(Path path, Mode mode, Future<Path> future);
+	public void get(Path path, Future<Path> future);
 
 	public void call(Path path, ProcedureParam param, Object[] arguments, Future<Object> future);
@@ -57,3 +59,9 @@
 	public JoinableDispatcher<Tree> getDispatcher();
 
+	public <A> void addListener(Path path, EventParam param, EventListener<A> listener, Class<A> argumentType, Future<Void> future);
+
+	public void removeListener(Path path, EventParam param, EventListener<?> listener, Future<Void> future);
+
+	public Registry getRegistry();
+
 }
Index: java/main/src/main/java/com/framsticks/core/TreeOperations.java
===================================================================
--- java/main/src/main/java/com/framsticks/core/TreeOperations.java	(revision 98)
+++ java/main/src/main/java/com/framsticks/core/TreeOperations.java	(revision 99)
@@ -2,5 +2,7 @@
 
 
+import java.util.HashSet;
 import java.util.List;
+import java.util.Set;
 
 import javax.annotation.Nonnull;
@@ -10,9 +12,12 @@
 import com.framsticks.communication.File;
 import com.framsticks.params.AccessInterface;
-import com.framsticks.params.CompositeParam;
+import com.framsticks.params.EventListener;
 import com.framsticks.params.FramsClass;
 import com.framsticks.params.ListAccess;
 import com.framsticks.params.Param;
 import com.framsticks.params.PrimitiveParam;
+import com.framsticks.params.UniqueListAccess;
+import com.framsticks.params.Util;
+import com.framsticks.params.types.EventParam;
 import com.framsticks.params.types.ObjectParam;
 import com.framsticks.params.types.ProcedureParam;
@@ -73,21 +78,57 @@
 
 			ListAccess listAccess = (ListAccess) bindAccess(node);
-			listAccess.clearValues();
+
+			Set<String> oldValuesIds = new HashSet<>();
+			for (Param p : listAccess.getParams()) {
+				oldValuesIds.add(p.getId());
+			}
+
+			// listAccess.clearValues();
 
 			AccessInterface elementAccess = listAccess.getElementAccess();
+			AccessInterface clonerInterface = elementAccess.cloneAccess();
+
 			loader.addAccessInterface(elementAccess);
 			MultiParamLoader.Status status;
+			int number = 0;
 			while ((status = loader.go()) != MultiParamLoader.Status.Finished) {
 				if (status == MultiParamLoader.Status.AfterObject) {
 					AccessInterface accessInterface = loader.getLastAccessInterface();
 
-					String id = listAccess.computeIdentifierFor(accessInterface.getSelected());
-					//TODO listAccessParam
-					CompositeParam param = Param.build().forAccess(accessInterface).id(id).finish(CompositeParam.class);
-					Object child = accessInterface.getSelected();
+					String id;
+					if (listAccess instanceof UniqueListAccess) {
+						id = ((UniqueListAccess) listAccess).computeIdentifierFor(accessInterface.getSelected());
+					} else {
+						id = Integer.toString(number);
+					}
+					++number;
+
+					Object childTo = listAccess.get(id, Object.class);
+					boolean newOne;
+					if (childTo == null) {
+						childTo = clonerInterface.createAccessee();
+						newOne = true;
+					} else {
+						assert oldValuesIds.contains(id);
+						newOne = false;
+					}
+					oldValuesIds.remove(id);
+					clonerInterface.select(childTo);
+					Util.takeAllNonNullValues(clonerInterface, accessInterface);
+					if (newOne) {
+						listAccess.set(id, childTo);
+					}
+
+					// listAccess.set(id, accessInterface.getSelected());
 					accessInterface.select(null);
-					assert child != null;
-					bindAccess(node).set(param, child);
+
 				}
+			}
+			/** It looks tricky for ArrayListAccess but should also work.
+ 			 *
+			 * They should be sorted.
+			 */
+			for (String id : oldValuesIds) {
+				listAccess.set(id, null);
 			}
 
@@ -170,6 +211,33 @@
 	}
 
-
-	/** This might not be correct. */
+	public static <A> void addListener(final Path path, final EventParam param, final EventListener<A> listener, final Class<A> argument, final Future<Void> future) {
+		final Tree tree = path.getTree();
+
+		dispatchIfNotActive(tree, new RunAt<Tree>(future) {
+			@Override
+			protected void runAt() {
+				tree.addListener(path, param, listener, argument, future);
+			}
+		});
+	}
+
+	public static void removeListener(final Path path, final EventParam param, final EventListener<?> listener, final Future<Void> future) {
+		final Tree tree = path.getTree();
+
+		dispatchIfNotActive(tree, new RunAt<Tree>(future) {
+			@Override
+			protected void runAt() {
+				tree.removeListener(path, param, listener, future);
+			}
+		});
+	}
+
+
+	/**
+	 *
+	 * If StackOverflow occurs in that loop in LocalTree it is probably caused
+	 * the by the fact, that get operation may find the object, but Path resolution
+	 * cannot.
+	 * */
 	public static void tryGet(final Tree tree, final String targetPath, final Future<Path> future) {
 		log.debug("resolve textual: " + targetPath + " for " + tree);
@@ -178,5 +246,6 @@
 			@Override
 			protected void runAt() {
-				final Path path = Path.to(tree, targetPath);
+				final Path path = Path.tryTo(tree, targetPath).tryResolveIfNeeded();
+				log.debug("found: " + path);
 				if (path.isResolved()) {
 					future.pass(path);
@@ -184,7 +253,12 @@
 				}
 
-				tree.get(path, Mode.FETCH, new FutureHandler<Path>(future) {
+				tree.get(path, new FutureHandler<Path>(future) {
 					@Override
 					protected void result(Path result) {
+						// if (result.isResolved(targetPath)) {
+						// 	future.pass(result);
+						// 	return;
+						// }
+						log.debug("retrying resolve textual: " + targetPath + " for " + tree + " with " + result);
 						tryGet(tree, targetPath, future);
 					}
@@ -198,3 +272,4 @@
 		return path.getTree().getInfoFromCache(path.getTop().getParam().getContainedTypeName());
 	}
+
 }
Index: java/main/src/main/java/com/framsticks/gui/Browser.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/Browser.java	(revision 98)
+++ java/main/src/main/java/com/framsticks/gui/Browser.java	(revision 99)
@@ -4,4 +4,6 @@
 import com.framsticks.gui.console.Console;
 import com.framsticks.gui.console.TrackConsole;
+import com.framsticks.gui.table.ColumnsConfig;
+import com.framsticks.gui.table.ListPanelProvider;
 import com.framsticks.params.annotations.AutoAppendAnnotation;
 import com.framsticks.params.annotations.FramsClassAnnotation;
@@ -57,8 +59,12 @@
 	}
 
+	protected final StandardPanelProvider standardPanelProvider;
+	protected final ListPanelProvider listPanelProvider;
+
 	public Browser() {
 		setName("browser");
 		JPopupMenu.setDefaultLightWeightPopupEnabled(false);
-		addPanelProvider(new StandardPanelProvider());
+		addPanelProvider(standardPanelProvider = new StandardPanelProvider());
+		addPanelProvider(listPanelProvider = new ListPanelProvider());
 
 		mainFrame = new MainFrame(Browser.this);
@@ -116,4 +122,9 @@
 
 	@AutoAppendAnnotation
+	public void addColumnsConfig(ColumnsConfig columnsConfig) {
+		listPanelProvider.addColumnsConfig(columnsConfig);
+	}
+
+	@AutoAppendAnnotation
 	public void addPopupMenuEntryProvider(PopupMenuEntryProvider popupMenuEntryProvider) {
 		popupMenuEntryProviders.add(popupMenuEntryProvider);
@@ -122,5 +133,5 @@
 	@AutoAppendAnnotation
 	public void addTree(Tree tree) {
-		log.info("adding tree: " + tree);
+		log.debug("adding tree: " + tree);
 		tree.setDispatcher(new SwingDispatcher<Tree>());
 		trees.add(tree);
@@ -155,31 +166,4 @@
 	}
 
-	public void createTreeNodeForChild(final Path path) {
-		assert !isActive();
-		//assert tree.isActive();
-
-		/*
-		 final TreeNode parentTreeNode = (TreeNode) child.getParent().getUserObject();
-		 if (parentTreeNode == null) {
-		 Dispatching.invokeDispatch(this, manager, new Runnable() {
-		 @Override
-		 public void run() {
-		 createTreeNodeForChild(child);
-		 }
-		 });
-		 return;
-		 }
-		 log.debug(child.getClass().getSimpleName() + " created: " + child);
-
-
-		 invokeLater(new Runnable() {
-		 @Override
-		 public void run() {
-		 parentTreeNode.getOrCreateChildTreeNodeFor(child);
-		 }
-		 });
-		 */
-	}
-
 	@Override
 	protected void joinableStart() {
@@ -288,22 +272,3 @@
 	}
 
-	// final protected Map<EventParam, Subscription<?>> userSubscriptions = new HashMap<>();
-	// public boolean hasSubscribed(EventParam param) {
-	// 	assert frame.isActive();
-	// 	return userSubscriptions.containsKey(param);
-	// }
-
-	// public void unsubscribe(EventParam eventParam) {
-	// 	assert frame.isActive();
-	// 	if (!hasSubscribed(eventParam)) {
-	// 		log.error("could not unsubscribe from " + eventParam);
-	// 		return;
-	// 	}
-	// 	userSubscriptions.get(eventParam).unsubscribe(new LoggingStateCallback(log, "unsubscribed " + eventParam));
-	// 	userSubscriptions.remove(eventParam);
-	// }
-
-
-
-
 }
